<template>
  <v-container class="categories-grid" fluid>
    <v-row>
      <v-col v-for="category in categoriesTree" :key="`categories-grid-${category.id}`" cols="3">
        <v-card class="categories-grid__card fill-height">
          <v-card-text>
            <v-btn text nuxt :to="`${baseUrl}/${category.id}`">
              <v-icon :color="iconColor" x-large v-text="category.icon"></v-icon>
              <span class="title ml-2" v-text="category.name"></span>
            </v-btn>

            <v-list dense class="ml-2">
              <v-hover
                v-for="categoryChild in category.children.primary"
                v-slot:default="{ hover }"
                :key="`categories-grid-child-${categoryChild.id}`"
              >
                <v-list-item nuxt :to="`${baseUrl}/${categoryChild.id}`">
                  <v-list-item-icon class="mr-3">
                    <v-icon
                      :color="hover ? '#D76889' : '#181847'"
                      :style="{ opacity: hover ? 1.0 : 0.3 }"
                      v-text="'mdi-chevron-right-box'"
                    ></v-icon>
                  </v-list-item-icon>
                  <v-list-item-content :class="{ 'transition-fast-in-fast-out': true, 'pl-2': hover }">
                    <v-list-item-title v-text="categoryChild.name"></v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-hover>

              <v-menu v-if="category.children.secondary.length" top transition="slide-y-transition">
                <template v-slot:activator="{ on }">
                  <v-hover v-slot:default="{ hover }">
                    <v-list-item :class="{ 'transition-fast-in-fast-out': true, 'pl-11': hover }" v-on="on">
                      <span class="mr-1">...{{ $t('button.get-additive') }}</span>
                      <span class="mr-1">{{ category.children.secondary.length }} </span>
                      <span class="mr-1">{{ $tc('text.categories', category.children.secondary.length) }}</span>
                    </v-list-item>
                  </v-hover>
                </template>

                <v-list dense>
                  <v-list-item
                    v-for="categoryChild in category.children.secondary"
                    :key="`categories-grid-child-${categoryChild.id}`"
                    nuxt
                    :to="`${baseUrl}/${categoryChild.id}`"
                    v-text="categoryChild.name"
                  ></v-list-item>
                </v-list>
              </v-menu>
            </v-list>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
export default {
  props: {
    categories: {
      type: Array,
      required: true,
    },

    iconColor: {
      type: String,
      default: '#D76889',
    },

    iconDefault: {
      type: String,
      default: 'mdi-cloud',
    },

    childrenLimit: {
      type: Number,
      default: 3,
    },
  },

  computed: {
    categoriesTree() {
      const { icons } = this.$store.state.catalog
      return this.categories.map(category => ({
        ...category,
        icon: icons[category.id] || this.iconDefault,
        children: {
          primary: category.children.slice(0, this.childrenLimit),
          secondary: category.children.length > this.childrenLimit ? category.children.slice(this.childrenLimit) : [],
        },
      }))
    },

    baseUrl() {
      return process.env.CATALOG_BASE_URL
    },
  },
}
</script>

<style lang="scss" scoped>
.categories-grid {
  .theme--light.v-list-item:not(.v-list-item--active):not(.v-list-item--disabled) {
    color: #181847 !important;
  }
}
</style>
